// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_tracing_TraceLogger_hpp
#define anna_core_tracing_TraceLogger_hpp

#include <anna/core/tracing/Logger.hpp>

namespace anna {

/**
   Clase usada por defecto para transferir los datos de la aplicacion al archivo de log.

   Para mas informacion:
      @li man syslog
      @li man syslogd
      @li man syslog.conf

   El destino del archivos de logs sera configurado mediante el archivo /etc/syslog.conf

   sta clase se registra como la facilidad (local0).

   \warning Sustituye a la clase Logger::DefaultWriter.
*/
class TraceLogger : public Logger::Writer {
private:
  /**
     Inicializa el sistema de historico de nuestra aplicacion.

     @param ident Identifica las trazas de nuestra aplicacion que apareceran  en el archivo de historico.
     Deberia ser un texto con entre 4 y 16 caracteres.
  */
  void initialize(const char* ident) throw();

  /**
     Transfiere el mensaje de trazas al log del sistema.

     @param level Nivel de las trazas que vamos a sacar.
     @param text Especificacion de formato del mensaje. Similar al usado en el comando sprintf.
  */
  void do_write(int level, const char* text, ...) throw();
};

}

#endif


