// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/core/DataBlock.hpp>
#include <anna/comm/Message.hpp>
#include <anna/comm/Server.hpp>

#include <anna/diameter.comm/ServerSessionReceiver.hpp>
#include <anna/diameter.comm/ServerSession.hpp>
#include <anna/diameter.comm/LocalServer.hpp>
#include <anna/core/functions.hpp>

// STL
#include <string>


using namespace anna::diameter::comm;

void ServerSessionReceiver::apply(anna::comm::ClientSocket& clientSocket, const anna::comm::Message& message)
throw(anna::RuntimeException) {
  LOGMETHOD(anna::TraceMethod tm("diameter::comm::ServerSessionReceiver", "apply", ANNA_FILE_LOCATION));
  a_session->receive(message);
}

void ServerSessionReceiver::eventBreakLocalConnection(const anna::comm::ClientSocket& clientSocket)
throw() {
  LOGMETHOD(anna::TraceMethod tm("diameter::comm::ServerSessionReceiver", "eventBreakLocalConnection", ANNA_FILE_LOCATION));
  //if (!a_session) return; // caso de los Engine::closeServerSession
  a_session->finalize();
  ///* (*) no need for: if (a_session->idle()) */a_session->getParent()->eraseServerSession(a_clientSocket);
}

